use msdb
go


if object_id('tempdb..#jobTracking') is not null
	drop table #jobTracking
go

-- Job level changes tracking
select x.AuditChangeID
, x.AuditChangeDate
, x.AuditChangeType
, x.AuditChangePerformedBy
, x.ApplicationName
, x.HostName
, x.job_id
, coalesce(j.name, x.name) as name
, case x.[enabled] when 1 then 'Y' when 0 then 'N' else null end as [Enabled]
, x.start_step_id
--, x.notify_email_operator_id
, o.name as EmailOperator
, case x.notify_level_email when 1 then 'When the job succeeds' when 2 then 'When the job fails' when 3 then 'When the job completes' else null end as EmailOperatorWhen
, x.xml_recset
into #jobTracking
from (	
		SELECT ajc.AuditChangeID
		, ajc.AuditChangeDate
		, ajc.AuditChangeType
		, ajc.AuditChangePerformedBy
		, ajc.ApplicationName
		, ajc.HostName
		, r.c.value('(job_id/text())[1]', 'UNIQUEIDENTIFIER' ) AS job_id
		, r.c.value('(name/text())[1]', 'SYSNAME') as name
		, r.c.value('(enabled/text())[1]', 'BIT') as [enabled]
		, r.c.value('(start_step_id/text())[1]', 'SMALLINT') as start_step_id
		, r.c.value('(notify_email_operator_id/text())[1]', 'SMALLINT') as notify_email_operator_id
		, r.c.value('(notify_level_email/text())[1]', 'SMALLINT') as notify_level_email
		, ajc.xml_recset
		FROM dbo.AuditJobChanges as ajc
		CROSS APPLY ajc.XML_RECSET.nodes('RecordSet') r(c)
		WHERE ajc.schemaname = 'dbo' and ajc.objectname = 'sysjobs'
	) as x
left join dbo.sysjobs as j on x.job_id = j.job_id
left join dbo.sysoperators as o on j.notify_email_operator_id = o.id
ORDER BY x.AuditChangeID

select * from #jobTracking order by AuditChangeID


-- Job steps level changes tracking
select x.AuditChangeID
, x.AuditChangeDate
, x.AuditChangeType
, x.AuditChangePerformedBy
, x.ApplicationName
, x.HostName
, x.job_id
, coalesce(j.name, j2.name) as name
, x.step_id
, x.step_name
, x.subsystem
, x.command
, x.database_name
--, x.on_success_action
--, x.on_success_step_id
, case x.on_success_action
		when 3 then 'Go to the next step' 
		when 2 then 'Quit the job reporting failure'
		when 1 then 'Quit the job reporting success'
		when 4 then 'Go to step ' + cast(x.on_success_step_id as varchar)
		else null
  end as OnSuccessAction
--, x.on_fail_action
--, x.on_fail_step_id
, case x.on_fail_action
		when 3 then 'Go to the next step' 
		when 2 then 'Quit the job reporting failure'
		when 1 then 'Quit the job reporting success'
		when 4 then 'Go to step ' + cast(x.on_fail_step_id as varchar)
		else null
  end as OnFailureAction
, x.xml_recset
from (	
		SELECT ajc.AuditChangeID
		, ajc.AuditChangeDate
		, ajc.AuditChangeType
		, ajc.AuditChangePerformedBy
		, ajc.ApplicationName
		, ajc.HostName
		, r.c.value('(job_id/text())[1]', 'UNIQUEIDENTIFIER' ) AS job_id
		, r.c.value('(step_id/text())[1]', 'SMALLINT') as step_id
		, r.c.value('(step_name/text())[1]', 'VARCHAR(150)') as step_name
		, r.c.value('(subsystem/text())[1]', 'VARCHAR(50)') as subsystem
		, r.c.value('(command/text())[1]', 'VARCHAR(MAX)') as command
		, r.c.value('(database_name/text())[1]', 'VARCHAR(50)') as database_name
		, r.c.value('(on_success_action/text())[1]', 'SMALLINT') as on_success_action
		, r.c.value('(on_success_step_id/text())[1]', 'SMALLINT') as on_success_step_id
		, r.c.value('(on_fail_action/text())[1]', 'SMALLINT') as on_fail_action
		, r.c.value('(on_fail_step_id/text())[1]', 'SMALLINT') as on_fail_step_id
		, ajc.xml_recset
		FROM dbo.AuditJobChanges as ajc
		CROSS APPLY ajc.XML_RECSET.nodes('RecordSet') r(c)
		WHERE ajc.schemaname = 'dbo' and ajc.objectname = 'sysjobsteps'
	) as x
left join dbo.sysjobs as j on x.job_id = j.job_id
--join dbo.sysjobsteps as js on x.job_id = js.job_id and x.step_id = js.step_id
left join (select distinct job_id, name from #jobTracking) as j2 on x.job_id = j2.job_id



