
-- Helpful Info:
-- http://craftydba.com/?page_id=880  -- Sep 2011 (SNESSUG) / Mar 2013 (SAT 184) / Apr 2013 (SAT 203) /Aug 2013 (SAT 235)


USE msdb
go


IF OBJECT_ID('[dbo].[AuditJobChanges]') IS NOT NULL 
  DROP TABLE [dbo].[AuditJobChanges]
;


-- Add the table
CREATE TABLE [dbo].[AuditJobChanges]
(
  [AuditChangeID] [numeric](18, 0) IDENTITY(1,1) NOT NULL,
  [AuditChangeDate] [datetime] NOT NULL,
  [AuditChangeType] [varchar](20) NOT NULL,
  [AuditChangePerformedBy] [nvarchar](256) NOT NULL,
  [ApplicationName] [nvarchar](128) NOT NULL,
  [HostName] [nvarchar](128) NOT NULL,
  [SchemaName] [sysname] NOT NULL,
  [ObjectName] [sysname] NOT NULL,
  [XML_RECSET] [xml] NULL,
 CONSTRAINT [PK_AJC_AuditChangeID] PRIMARY KEY CLUSTERED ([AuditChangeID] ASC)
) ON [PRIMARY]
;

-- Add defaults for key information
ALTER TABLE [dbo].[AuditJobChanges] ADD CONSTRAINT [DF_AJC_AuditChangeDate] DEFAULT (getdate()) FOR [AuditChangeDate];
ALTER TABLE [dbo].[AuditJobChanges] ADD CONSTRAINT [DF_AJC_AuditChangeType] DEFAULT ('?') FOR [AuditChangeType];
ALTER TABLE [dbo].[AuditJobChanges] ADD CONSTRAINT [DF_AJC_AuditChangePerformedBy] DEFAULT (coalesce(suser_sname(),'?')) FOR [AuditChangePerformedBy];
ALTER TABLE [dbo].[AuditJobChanges] ADD CONSTRAINT [DF_AJC_ApplicationName] DEFAULT (coalesce(app_name(),'?')) FOR [ApplicationName];
ALTER TABLE [dbo].[AuditJobChanges] ADD CONSTRAINT [DF_AJC_HostName] DEFAULT (coalesce(host_name(),'?')) FOR [HostName];

GO


